/* hardzuf.c       letzte Aenderung: 26.9.2009
 Ueber die serielle Schnittstelle (UART) Daten senden
 Version: 0.0
 Prozessor: Atmega8, 8MHz oder 3.6864MHz
 Schaltung: Port B0,B1,B2 mit LEDs verbunden (zum Testen)
            Port D4 mit Rauschgenerator verbunden
 Autor: Rolf Pfister
 Copyright: Freeware
 History:
 26.9.2009	Erstellung
*/

#include <avr/io.h>
#include <stdio.h>
typedef unsigned char uchar;

static volatile uchar bytesenden=0;

//Quarzfrequenz in Hz:
#define QUARZ 8000000
//fuer das myAVR-Board:
//#define QUARZ 3686400

void usart_putc(uchar c)
{
 while(!(UCSRA & (1<<UDRE))) ;//warten bis Puffer leer
 UDR=c;
}
void usart_print(char *s)
{
 uchar c;
 while(c= *s++) usart_putc(c);
}

/**
volatile int vi=0,vj=0,vk=0;
void milliwait(int n) //ungefaehr n millisekunden warten
{
 for(vi=0;vi<n;vi++)
  for(vj=0;vj<114;vj++)
    vk=vi+vj;
}
volatile char vc=0;
void microwait(int n) //ungefaehr n microsekunden warten
{
 for(vc=n/4;--vc!=0;)
  ;
}
**/

int main(void)
{
 int baudrate;
 //char str[80];//test
 uchar c,i,j,n=0,zeit=0,zufallsbit=0;
 DDRB  = 0x3F; //PortB PB0-5 als Ausgaenge
 PORTB = 0; //alle LEDs aus
 DDRC  = 0x03; //PortC PC0-1 als Ausgaenge
 PORTC = 0; //alle LEDs aus
 DDRD  = 0; //PortD alles Eingaenge
 PORTD = 0x1C; //D2 D3 D4 mit Pullup-Widerstaenden
               //(Eingang von Rauschgenerator, und Taster zum Testen)
 baudrate=QUARZ/16/9600-1;
 //UBRRH=(baudrate>>8);
 UBRRL=(baudrate&0xFF);
 UCSRB = (1<<RXEN)|(1<<TXEN);
 // UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);

 /*
 while(1) //Testschlaufe zum milliwait() und microwait() testen
  {int j;
   PORTB=n++;
   for(j=0;j<1000;j++)
    microwait(1000);
  }
 */

 while(1) //Hauptschlaufe
   {n++;
    //PORTB=n;//test
    //usart_print("Hallo 0123456789\r\n"); //test1
    //sprintf(str,"Hallo %d\r\n",n); usart_print(str); //test2
    for(c=0,i=0;i<6;i++) //c jeweils mit 6 Bits fuellen
       {//Einfachste Variante: Eingang==Zufallsbit
	//zufallsbit = (PIND&0x10)>>4;
	//milliwait(1);
	//microwait(100);

	//Variante2: Zeit zwischen 2 Ereignissen messen
	zeit=0;
	while((PIND&0x10)==0) ;//warten bis Eingang==1
	for(j=0;j<10;j++) {//Zeit fuer 10 Ereignisse messen
	while(PIND&0x10) zeit++;//warten bis Eingang==0
	while((PIND&0x10)==0) zeit++;//warten bis Eingang==1
	}
	zufallsbit=zeit&1;//Letztes Bit der gemessenen Zeit

	c += c+zufallsbit;
       }
    //c ist jetzt eine Zufallszahl zwischen 0 und 63 inklusive Grenzen
    //PORTB=c;//test
    PORTB=(zeit>>5);//test wenn nur unterste 3 Bits angeschlossen
    PORTB=zeit; PORTC=(zeit>>6);//test mit allen 8 LEDs angeschlossen
    c+=0x21; //c ist jetzt ein Zeichen zwischen 0x21 und 0x60 inklusive
             //und somit ein darstellbares ASCII-Zeichen
    usart_putc(c);
    //if((n&0x3F)==0) usart_print("\r\n"); //nach 64 Zeichen jeweil ein CR LF
    if((n&0x3F)==0) usart_print("\n"); //nach 64 Zeichen jeweil ein LF
   }
 return 0;
}
